dbus-0.10.13: A client library for the D-Bus IPC system.

Safe Haskell | None
Language | Haskell98

DBus.Introspection

Contents

- XML conversion
- Objects
- Interfaces
- Methods
  - Method arguments
- Signals
  - Signal arguments
- Properties

Synopsis

- parseXML :: ObjectPath -> String -> Maybe Object
- formatXML :: Object -> Maybe String
- data Object
- object :: ObjectPath -> Object
- objectPath :: Object -> ObjectPath
- objectInterfaces :: Object -> [Interface]
- objectChildren :: Object -> [Object]
- data Interface
- interface :: InterfaceName -> Interface
- interfaceName :: Interface -> InterfaceName
- interfaceMethods :: Interface -> [Method]
- interfaceSignals :: Interface -> [Signal]
- interfaceProperties :: Interface -> [Property]
- data Method
- method :: MemberName -> Method
- methodName :: Method -> MemberName
- methodArgs :: Method -> [MethodArg]
- data MethodArg
- methodArg :: String -> Type -> Direction -> MethodArg
- methodArgName :: MethodArg -> String
- methodArgType :: MethodArg -> Type
- methodArgDirection :: MethodArg -> Direction
- data Direction
- directionIn :: Direction
- directionOut :: Direction
- data Signal
- signal :: MemberName -> Signal
- signalName :: Signal -> MemberName
- signalArgs :: Signal -> [SignalArg]
- data SignalArg
- signalArg :: String -> Type -> SignalArg
- signalArgName :: SignalArg -> String
- signalArgType :: SignalArg -> Type
- data Property
- property :: String -> Type -> Property
- propertyName :: Property -> String
- propertyType :: Property -> Type
- propertyRead :: Property -> Bool
- propertyWrite :: Property -> Bool

# XML conversion

parseXML :: ObjectPath -> String -> Maybe Object #

formatXML :: Object -> Maybe String #

# Objects

data Object #

Instances

Eq Object # |
Instance details Defined in DBus.Introspection Methods (==) :: Object -> Object -> Bool # (/=) :: Object -> Object -> Bool #
Show Object # |
Instance details Defined in DBus.Introspection Methods showsPrec :: Int -> Object -> ShowS # show :: Object -> String # showList :: [Object] -> ShowS #

object :: ObjectPath -> Object #

objectPath :: Object -> ObjectPath #

objectInterfaces :: Object -> [Interface] #

objectChildren :: Object -> [Object] #

# Interfaces

data Interface #

Instances

Eq Interface # |
Instance details Defined in DBus.Introspection Methods (==) :: Interface -> Interface -> Bool # (/=) :: Interface -> Interface -> Bool #
Show Interface # |
Instance details Defined in DBus.Introspection Methods showsPrec :: Int -> Interface -> ShowS # show :: Interface -> String # showList :: [Interface] -> ShowS #

interface :: InterfaceName -> Interface #

interfaceName :: Interface -> InterfaceName #

interfaceMethods :: Interface -> [Method] #

interfaceSignals :: Interface -> [Signal] #

interfaceProperties :: Interface -> [Property] #

# Methods

data Method #

Instances

Eq Method # |
Instance details Defined in DBus.Introspection Methods (==) :: Method -> Method -> Bool # (/=) :: Method -> Method -> Bool #
Show Method # |
Instance details Defined in DBus.Introspection Methods showsPrec :: Int -> Method -> ShowS # show :: Method -> String # showList :: [Method] -> ShowS #

method :: MemberName -> Method #

methodName :: Method -> MemberName #

methodArgs :: Method -> [MethodArg] #

## Method arguments

data MethodArg #

Instances

Eq MethodArg # |
Instance details Defined in DBus.Introspection Methods (==) :: MethodArg -> MethodArg -> Bool # (/=) :: MethodArg -> MethodArg -> Bool #
Show MethodArg # |
Instance details Defined in DBus.Introspection Methods showsPrec :: Int -> MethodArg -> ShowS # show :: MethodArg -> String # showList :: [MethodArg] -> ShowS #

methodArg :: String -> Type -> Direction -> MethodArg #

methodArgName :: MethodArg -> String #

methodArgType :: MethodArg -> Type #

methodArgDirection :: MethodArg -> Direction #

data Direction #

Instances

Eq Direction # |
Instance details Defined in DBus.Introspection Methods (==) :: Direction -> Direction -> Bool # (/=) :: Direction -> Direction -> Bool #
Show Direction # |
Instance details Defined in DBus.Introspection Methods showsPrec :: Int -> Direction -> ShowS # show :: Direction -> String # showList :: [Direction] -> ShowS #

directionIn :: Direction #

directionOut :: Direction #

# Signals

data Signal #

Instances

Eq Signal # |
Instance details Defined in DBus.Introspection Methods (==) :: Signal -> Signal -> Bool # (/=) :: Signal -> Signal -> Bool #
Show Signal # |
Instance details Defined in DBus.Introspection Methods showsPrec :: Int -> Signal -> ShowS # show :: Signal -> String # showList :: [Signal] -> ShowS #

signal :: MemberName -> Signal #

signalName :: Signal -> MemberName #

signalArgs :: Signal -> [SignalArg] #

## Signal arguments

data SignalArg #

Instances

Eq SignalArg # |
Instance details Defined in DBus.Introspection Methods (==) :: SignalArg -> SignalArg -> Bool # (/=) :: SignalArg -> SignalArg -> Bool #
Show SignalArg # |
Instance details Defined in DBus.Introspection Methods showsPrec :: Int -> SignalArg -> ShowS # show :: SignalArg -> String # showList :: [SignalArg] -> ShowS #

signalArg :: String -> Type -> SignalArg #

signalArgName :: SignalArg -> String #

signalArgType :: SignalArg -> Type #

# Properties

data Property #

Instances

Eq Property # |
Instance details Defined in DBus.Introspection Methods (==) :: Property -> Property -> Bool # (/=) :: Property -> Property -> Bool #
Show Property # |
Instance details Defined in DBus.Introspection Methods showsPrec :: Int -> Property -> ShowS # show :: Property -> String # showList :: [Property] -> ShowS #

property :: String -> Type -> Property #

propertyName :: Property -> String #

propertyType :: Property -> Type #

propertyRead :: Property -> Bool #

propertyWrite :: Property -> Bool #